;; Analiza zaimkw


;; Tabela klasyfikacji zaimkw. Pniej przenios j do util.lisp
(defvar pronoun-type
  '((ZO  . "Zaimek osobowy")
    (ZZ  . "Zaimek zwrotny")
    (ZD  . "Zaimek dzierawczy")
    (ZW  . "Zaimek wskazujcy")
    (ZP  . "Zaimek pytajco-wzgldny")
    (ZOK . "Zaimek okrelajcy")
    (ZPR . "Zaimek przeczcy")
    (ZN  . "Zaimek nieokrelony")))

(defvar pronoun-dictionary nil)

(setq pronoun-dictionary
      ;; Zaimki osobowe:
      ;;
      ;; Zaimek       'ZO Osoba Przypadek Liczba [Rodzaj] 
      '(("ja"          ZO 1     M          LP)
	("mnie"        ZO 1     (D C B Mc) LP)
	("mi"          ZO 1     C          LP)
	("mi"         ZO 1     B          LP)
	("mn"         ZO 1     N          LP)
	
	("ty"          ZO 2     M          LP)
	("ciebie"      ZO 2     (D B)      LP)
	("tobie"       ZO 2     (C M)      LP)
	("ci"      . ((ZO 2     C          LP)
      ;;       	       ZW Przypadek Liczba [Rodzaj]
	              (ZW M         LM         RM)))
	("ci"         ZO 2     B          LP)
	("tob"        ZO 2     N          LP)

	("siebie"      ZZ 2     (D B)      LP)
	("sobie"       ZZ 2     (C Mc)     LP)
	("si"         ZZ 2     B          LP)
	("sob"        ZZ 2     N          LP)
		       	        
	("my"          ZO 1     M          LM)
	("nas"         ZO 1     (D B Mc)   LM)
	("nam"         ZO 1     C          LM)
	("nami"        ZO 1     N          LM)
		                
	("wy"          ZO 2     M          LM)
	("was"         ZO 2     (D B Mc)   LM)
	("wam"         ZO 2     C          LM)
	("wami"        ZO 2     N          LM)
		   
	("on"          ZO 3     M          LP    RM)
		   
        ("jego"   .  ((ZO 3     (D B)      LP    RM)
		      (ZO 3     D          LP    RN)))
        ("go"     .  ((ZO 3     (D B)      LP    RM)
		      (ZO 3     D          LP    RN))) 
	 
        ("niego"  .  ((ZO 3     (D B)      LP    RM)
		      (ZO 3     D          LP    RN))) 

	("nim"         ZO 3     (N Mc)     LP)
		   
	("ono"         ZO 3     M          LP    RN)
	("jemu"        ZO 3     C          LP)
	("mu"          ZO 3     C          LP)
	("niemu"       ZO 3     C          LP)
	("je"    .   ((ZO 3     B          LP    RN)
		      (ZO 3     B          LM)))   
	("nie"   .   ((ZO 3     B          LP    RN)
		      (ZO 3     B          LM)))   
		   
	("ona"         ZO 3     M          LP    R)
	("jej"         ZO 3     (D C)      LP    R)
	("niej"        ZO 3     (D C)      LP    R)
	("j"          ZO 3     B          LP    R)
	("ni"         ZO 3     (B N)      LP    R)
	("niej"        ZO 3     Mc         LP    R)
		                	         
	("oni"         ZO 3     M          LM    RM)
	("ich"         ZO 3     (D B)      LM)   
	("nich"        ZO 3     (D B Mc)   LM)   
	("im"          ZO 3     C          LM)   
	("nim"         ZO 3     C          LM)   
	("nimi"        ZO 3     N          LM)   

	;; Zaimki dzierawcze
	;;
	;; Zaimek      ZD Osoba Przypadek Liczba Liczba_Posiadania Rodzaj_Posiadania
	("mj"         ZD 1     M         LP     LP                RM)
	("moja"        ZD 1     M         LP     LP                R)
	("ma"          ZD 1     M         LP     LP                R)

	("moje" .    ((ZD 1     M         LP     LP                RN)
		      (ZD 1     (M B)     LP     LM))) 
	("me"   .    ((ZD 1     M         LP     LP                RN)
		      (ZD 1     (M B)     LP     LM))) 
		
	("mojego" .  ((ZD 1     D         LP     LP                (RM RN))
		      (ZD 1     B         LP     LP                RM)))      
	("mego"   .  ((ZD 1     D         LP     LP                (RM RN))
		      (ZD 1     B         LP     LP                RM)))      
	("mojemu"      ZD 1     C         LP     LP                (RM RN))
	("memu"        ZD 1     C         LP     LP                (RM RN))
	("moim"  .   ((ZD 1     (N Mc)    LP     LP                (RM RN))
		      (ZD 1     C         LP     LM)))
	("mym"   .   ((ZD 1     (N Mc)    LP     LP                (RM RN))
		      (ZD 1     C         LP     LM))) 
	("mojej"       ZD 1     (D C Mc)  LP     LP                R)
	("mej"         ZD 1     (D C Mc)  LP     LP                R)
	("moj"        ZD 1     (B N)     LP     LP                R)
	("m"          ZD 1     (B N)     LP     LP                R)

	("moi"         ZD 1     M         LP     LM)
	("moich"  .  ((ZD 1     (D Mc)    LP     LM)
		      (ZD 1     B         LP     LM                RM)))  
	("mych"   .  ((ZD 1     (D Mc)    LP     LM)
		      (ZD 1     B         LP     LM                RM))) 

	("moimi"       ZD 1     N         LP     LM)
	
	("twj"        ZD 2     M         LP     LP                RM)
	("twoja"       ZD 2     M         LP     LP                R)
	("twa"         ZD 2     M         LP     LP                R)

	("twoje" .   ((ZD 2     M         LP     LP                RN)
		      (ZD 2     (M B)     LP     LM)))        
	("twe"   .   ((ZD 2     M         LP     LP                RN)
		      (ZD 2     (M B)     LP     LM)))      
		
	("twojego" . ((ZD 2     D         LP     LP                (RM RN))
		      (ZD 2     B         LP     LP                RM)))     
	("twego"   . ((ZD 2     D         LP     LP                (RM RN))
		      (ZD 2     B         LP     LP                RM)))     
	("twojemu"     ZD 2     C         LP     LP                (RM RN))
	("twemu"       ZD 2     C         LP     LP                (RM RN))
	("twoim"       ZD 2     (N Mc)    LP     LP                (RM RN))
	("twoim"       ZD 2     C         LP     LM)
	("twym"        ZD 2     (N Mc)    LP     LP                (RM RN))
	("twojej"      ZD 2     (D C Mc)  LP     LP                R)
	("twej"        ZD 2     (D C Mc)  LP     LP                R)
	("twoj"       ZD 2     (B N)     LP     LP                R)
	("tw"         ZD 2     (B N)     LP     LP                R)

	("twoi"        ZD 2     M         LP     LM)
	
	("twoich"  . ((ZD 2     (D Mc)    LP     LM)
		      (ZD 2     B         LP     LM                RM))) 
	("twych"   . ((ZD 2     (D Mc)    LP     LM)
		      (ZD 2     B         LP     LM                RM))) 

	("twoimi"      ZD 2     N         LP     LM)
	
	("swj"        ZD 2     M         LP     LP                RM)
	("swoja"       ZD 2     M         LP     LP                R)
	("swa"         ZD 2     M         LP     LP                R)

	("swoje"   . ((ZD 2     M         LP     LP                RN)
		      (ZD 2     (M B)     LP     LM)))      
	("swe"     . ((ZD 2     M         LP     LP                RN)
		      (ZD 2     (M B)     LP     LM)))      
		
	("swojego" . ((ZD 2     D         LP     LP                (RM RN))
		      (ZD 2     B         LP     LP                RM)))  
	("swego"   . ((ZD 2     D         LP     LP                (RM RN))
		      (ZD 2     B         LP     LP                RM)))  
	("swojemu"     ZD 2     C         LP     LP                (RM RN))
	("swemu"       ZD 2     C         LP     LP                (RM RN))
	("swoim"       ZD 2     (N Mc)    LP     LP                (RM RN))
	("swoim"       ZD 2     C         LP     LM)
	("swym"        ZD 2     (N Mc)    LP     LP                (RM RN))
	("swojej"      ZD 2     (D C Mc)  LP     LP                R)
	("swej"        ZD 2     (D C Mc)  LP     LP                R)
	("swoj"       ZD 2     (B N)     LP     LP                R)
	("sw"         ZD 2     (B N)     LP     LP                R)

	("swoi"        ZD 2     M         LP     LM)
					  
	("swoich"  . ((ZD 2     (D Mc)    LP     LM)
		      (ZD 2     B         LP     LM                RM)))  
	("swych"   . ((ZD 2     (D Mc)    LP     LM)
		      (ZD 2     B         LP     LM                RM)))  
					  
	("swoimi"      ZD 2     N         LP     LM)
					  
					  
	("nasz"   .  ((ZD 1     M         LM     LP                RM)
		      (ZD 1     B         LM     LP)))
	("nasze"  .  ((ZD 1     (M B)     LM     LP                RN)
		      (ZD 1     (M B)     LM     LM)))
	("nasza"       ZD 1     M         LM     LP                R)
	("naszego" . ((ZD 1     D         LM     LP               (RM RN))
		      (ZD 1     B         LM     LP               RM)))
	("naszej"      ZD 1     (D C Mc)  LM     LP               R)
	("naszemu"     ZD 1     C         LM     LP               (RM RN))
	("nasz"       ZD 1     (B N)     LM     LP               R)
	("naszym"  . ((ZD 1     (N Mc)    LM     LP               (RM RN))
		      (ZD 1     C         LM     LM)))
	("nasi"        ZD 1     M         LM     LM               RM)
	("naszych" . ((ZD 1     (D Mc)    LM     LM)
		      (ZD 1     B         LM     LM               RM)))
	("naszymi"     ZD 1     N         LM     LM)
					  
	("wasz"   .  ((ZD 2     M         LM     LP                RM)
		      (ZD 2     B         LM     LP)))
	("wasze"  .  ((ZD 2     (M B)     LM     LP                RN)
		      (ZD 2     (M B)     LM     LM)))
	("wasza"       ZD 2     M         LM     LP                R)
	("waszego" . ((ZD 2     D         LM     LP               (RM RN))
		      (ZD 2     B         LM     LP               RM)))
	("waszej"      ZD 2     (D C Mc)  LM     LP               R)
	("waszemu"     ZD 2     C         LM     LP               (RM RN))
	("wasz"       ZD 2     (B N)     LM     LP               R)
	("waszym"  . ((ZD 2     (N Mc)    LM     LP               (RM RN))
		      (ZD 2     C         LM     LM)))
	("wasi"        ZD 2     M         LM     LM               RM)
	("waszych" . ((ZD 2     (D Mc)    LM     LM)
		      (ZD 2     B         LM     LM               RM)))
	("waszymi"     ZD 2     N         LM     LM)
					  
	;; Zaimki pytajco-wzgldne
	;; Zaimek      ZP Przypadek [Liczba [Rodzaj]]
	("kto"         ZP M)
	("kogo"        ZP (D B))
	("komu"        ZP C)
	("kim"         ZP (N Mc))

	("co"          ZP (M B))
	("czego"       ZP D)
	("czemu"       ZP C)
	("czym"        ZP (N Mc))

	("ktry"       ZP (M B)     LP     RM)
	("ktre"  .  ((ZP (M B)     LP     RN)
                      (ZP M         LM)))
	("ktra"       ZP M         LP     R)
	("ktrego" . ((ZP (D B)     LP     RM)
		      (ZP D         LP     RN)))
	("ktrej"      ZP (D C Mc)  LP     R)
	("ktremu"     ZP C         LP     (RM RN))
	("ktr"       ZP (B N)     LP     R)
	("ktrym"      ZP (N Mc)    LP     (RM RN))

	("ktrzy"      ZP M         LM     RM)
	("ktrych" . ((ZP (D B N)   LM     RM)
		      (ZP (D Mc)    LM     (RN R))))
	("ktrym"      ZP C         LM)
	("ktrymi"     ZP N         LM)

	("czyj"        ZP M         LP     RM)
	("czyje"   . ((ZP M         LP     RN)
		      (ZP (M B)     LM     (RN R))))
	("czyjego"     ZP D         LP     (RM RN))
	("czyjej"      ZP (D C M)   LP     R)
	("czyjemu"     ZP C         LP     (RM RN))
	("czyim"       ZP (N Mc)    LP     (RM RN))
	("czyi"        ZP M         LM     RM)
	("czyje"       ZP (M B)     LM     (RN R))
	("czyich"   .((ZP (D Mc)    LM)
		      (ZP B         LM     RM)))
	("czyimi"      ZP N         LM)

	;; "Ile" odmienia si jak liczebniki gwne od 5
	("ile"         ZP M         LM)     ;; w gruncie rzeczy, liczba nieokrelona
	("ilu"      .((ZP M         LM     RM) 
		      (ZP (D C B N Mc) LM))) 
	
	;; Zaimki przeczce
	;; Zaimek      ZPR Przypadek 
	("nikt"        ZPR M)
	("nikogo"      ZPR (D B))
	("nikomu"      ZPR C)
	("nikim"       ZPR (N Mc))

	("nic"         ZPR (M B))
	("niczego"     ZPR D)
	("niczemu"     ZPR C)
	("niczym"      ZPR (N Mc))

	("jaki"        ZP (M B)     LP     RM)
	("jakie"  .  ((ZP (M B)     LP     RN)
                      (ZP M         LM)))
	("jaka"        ZP M         LP     R)
	("jakiego" . ((ZP (D B)     LP     RM)
		      (ZP D         LP     RN)))
	("jakiej"      ZP (D C Mc)  LP     R)
	("jakiemu"     ZP C         LP     (RM RN))
	("jak"        ZP (B N)     LP     R)
	("jakim"   . ((ZP (N Mc)    LP     (RM RN))
	              (ZP C         LM)))
	("jacy"        ZP M         LM     RM)
	("jakich"  . ((ZP (D B N)   LM     RM)
		      (ZP (D Mc)    LM     (RN R))))
	("jakimi"      ZP N         LM)

	;; Zaimki wskazujce
	;; Zaimek      ZW Przypadek Liczba [Rodzaj]
	("ten"         ZW (M B)     LP     RM)
	("to"          ZW (M B)     LP     RN)
	("ta"          ZW M         LP     R)
	("tego"   .  ((ZW (D B)     LP     RM)
		      (ZW D         LP     RN)))
	("tej"         ZW (D C Mc)  LP     R)
	("temu"        ZW C         LP     (RM RN))
	("t"          ZW B         LP     R)
	("tym"         ZW (N Mc)    LP     (RM RN))
	("t"          ZW N         LP     R) ;; oraz B, zamiast "t", w
	                                       ;; jzyku potocznym
	("te"          ZW M         LM)
	("tych"   .  ((ZW (D B N)   LM     RM)
		      (ZW (D Mc)    LM     (RN R))))
	("tym"         ZW C         LM)
	("tymi"        ZW N         LM)

	("tamten"      ZW (M B)     LP     RM)
	("tamto"       ZW (M B)     LP     RN)
	("tamta"       ZW M         LP     R)
	("tamtego" . ((ZW (D B)     LP     RM)
		      (ZW D         LP     RN)))
	("tamtej"      ZW (D C Mc)  LP     R)
	("tamtemu"     ZW C         LP     (RM RN))
	("tamtym"      ZW (N Mc)    LP     (RM RN))
	("tamt"       ZW (B N)        LP     R) 
	("tamci"       ZW M         LM     RM)
	("tamte"       ZW M         LM)
	("tamtych" . ((ZW (D B N)   LM     RM)
		      (ZW (D Mc)    LM     (RN R))))
	("tamtym"      ZW C         LM)
	("tamtymi"     ZW N         LM)

	("w"          ZW M         LP     RM)
	("owa"         ZW M         LP     R)
	("owo"         ZW (M B)     LP     RN)
	("owego"   . ((ZW (D B)     LP     RM)
		      (ZW D         LP     RN)))
	("owej"        ZW (D Mc)    LP     R)
	("owemu"       ZW C         LP     (RM RN))
	("ow"         ZW (B N)     LP     R)
	("owym"    . ((ZW (N Mc)    LP     (RM RN))
		      (ZW C         LM)))
	("owi"         ZW M         LM     RM)
	("owe"         ZW (M B)     LM     (RN R))
	("owych"   . ((ZW (D B Mc)  LM     RM)
		      (ZW (D Mc)    LM)    (RN R)))
	("owymi"       ZW N         LM)
	 
	;; Zaimki okrelajce
	;; Zaimek      ZOK Przypadek Liczba [Rodzaj] 
	
	("taki"        ZOK (M B)     LP     RM)
	("takie"  .  ((ZOK (M B)     LP     RN)
                      (ZOK M         LM)))
	("taka"        ZOK M         LP     R)
	("takiego" . ((ZOK (D B)     LP     RM)
		      (ZOK D         LP     RN)))
	("takiej"      ZOK (D C Mc)  LP     R)
	("takiemu"     ZOK C         LP     (RM RN))
	("tak"        ZOK (B N)     LP     R)
	("takim"   . ((ZOK (N Mc)    LP     (RM RN))
	              (ZOK C         LM)))

	("tacy"        ZOK M         LM     RM)
	("takich"  . ((ZOK (D B N)   LM     RM)
		      (ZOK (D Mc)    LM     (RN R))))
	("takimi"      ZOK N         LM)

	("sam"         ZOK (M B)     LP     RM)
	("samo"        ZOK (M B)     LP     RN)
	("sami"        ZOK M         LP     R)
	("samego"  . ((ZOK (D B)     LP     RM)
		      (ZOK D         LP     RN)))
	("samej"       ZOK (D C Mc)  LP     R)
	("samemu"      ZOK C         LP     (RM RN))
	("sam"        ZOK (B N)     LP     R)
	("samim"       ZOK (N Mc)    LP     (RM RN))

	("sami"        ZOK M         LM     RM)
	("same"        ZOK M         LM)
	("samych"  . ((ZOK (D B N)   LM     RM)
		      (ZOK (D Mc)    LM     (RN R))))
	("samym"       ZOK C         LM)
	("samymi"      ZOK N         LM)))

;; Szukanie sowa WORD w tabeli zaimkw
(defun lookup-pronoun (word)
  (let ((d (assoc word pronoun-dictionary :test #'string-equal)))
    (when d
      (cdr d))))

;; Jeli WORD jest zaimkiem pytajcym, zwraca jego dane, zamieniajc
;; charakterystyk ZP na ZN (zaimek nieokrelony)
(defun indefinite-pronoun (word)
  (let ((d (lookup-pronoun word)))
    (when d
      (if (listp (car d))
	  (when (eq (caar d) 'ZP)
	    (mapcar #'(lambda (x)
			      (append (list 'ZN) (nthcdr 1 x)))
		    d))
	(when (eq (car d) 'ZP)
	  (append (list 'ZN) (nthcdr 1 d)))))))

(defun subjective-pronoun-p (p)
  (and
   (not (eq (pronoun-get-type p) 'ZP))
   (member 'M (to-list (pronoun-get-case p)))))

;; Analiza zaimka
(defun analyze-pronoun (word)
  (cond
   ((match-ending word "")
    (indefinite-pronoun (remove-ending word 1)))
   ((match-ending word "kolwiek")
    (indefinite-pronoun (remove-ending word 7)))
   (t
    (lookup-pronoun word))))

(defun get-pronoun (word)
  (let ((x (analyze-pronoun word)))
    (when x
      (if (symbolp (car x))
	  (list x)
	x))))

(defun read-and-print-pronoun ()
  (format t "~&Zaimek: ")
  (let ((line (read-line)))
    (if (string-equal line "")
	nil
      (let ((r (analyze-pronoun line)))
	(if r
	    (if (listp (car r))
		(let ((n 0))
		  (mapcar #'(lambda (x)
			      (format t "~A: " n)
			      (setq n (1+ n))
			      (print-result x))
			  r))
	      (print-result r))
	  (format t "Nie jest zaimkiem?~%"))
	t))))

(defun check-pronouns ()
  (while (read-and-print-pronoun)))

;; Sprawdzanie
;(load "util.lisp")
;(check-pronouns)
  
		  
